<?php
require_once dirname(__FILE__) . '/../beek-widget-extention.php';

class BeekCallToAction extends WP_Widget {

	function BeekCallToAction() {
		parent::__construct('BeekCallToAction', 'Beek Call to Action Widget', array('description' => __('Simple Call to Action Widget.', 'beek-widget-extention')));
	}

	function form($instance) {
		if ($instance) {
			$text = esc_attr((array_key_exists('text', $instance) ? $instance['text'] : ''));
			$url = esc_attr((array_key_exists('url', $instance) ? $instance['url'] : ''));
			$reverse = esc_attr((array_key_exists('reverse', $instance) ? $instance['reverse'] : 'normal'));
			$color = esc_attr((array_key_exists('color', $instance) ? $instance['color'] : 'black'));
			$width = esc_attr((array_key_exists('width', $instance) ? $instance['width'] : '80'));
			$size = esc_attr((array_key_exists('size', $instance) ? $instance['size'] : 'middle'));
		} else {
			$text = '';
			$url = '';
			$reverse = 'normal';
			$color = 'black';
			$width = '70';
			$size = 'middle';
		}
		?>
		<div class="bwe-widget-setting">
			<p>
				<label for="<?php echo $this->get_field_id('text'); ?>">
					<?php _e('Text', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('text'); ?>"
					   name="<?php echo $this->get_field_name('text'); ?>"
					   type="text"
					   value="<?php echo $text; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('url'); ?>">
					<?php _e('URL', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('url'); ?>"
					   name="<?php echo $this->get_field_name('url'); ?>"
					   type="text"
					   value="<?php echo $url; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('reverse'); ?>">
					<?php _e('Call to Action Color Reverse', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('reverse'); ?>"
						name="<?php echo $this->get_field_name('reverse'); ?>"
						type="text">
					<option<?php ($reverse == 'normal') ? print ' selected ' : print ''; ?>>normal</option>
					<option<?php ($reverse == 'reverse') ? print ' selected ' : print ''; ?>>reverse</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('color'); ?>">
					<?php _e('Call to Action Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('color'); ?>"
						name="<?php echo $this->get_field_name('color'); ?>"
						type="text">
					<option<?php ($color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('width'); ?>">
					<?php _e('Call to Action Width', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('width'); ?>"
						name="<?php echo $this->get_field_name('width'); ?>"
						type="text">
					<option<?php ($width == '100') ? print ' selected ' : print ''; ?>>100</option>
					<option<?php ($width == '90') ? print ' selected ' : print ''; ?>>90</option>
					<option<?php ($width == '80') ? print ' selected ' : print ''; ?>>80</option>
					<option<?php ($width == '70') ? print ' selected ' : print ''; ?>>70</option>
					<option<?php ($width == '60') ? print ' selected ' : print ''; ?>>60</option>
					<option<?php ($width == '50') ? print ' selected ' : print ''; ?>>50</option>
					<option<?php ($width == '40') ? print ' selected ' : print ''; ?>>40</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('size'); ?>">
					<?php _e('Call to Action Font Size', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('size'); ?>"
						name="<?php echo $this->get_field_name('size'); ?>"
						type="text">
					<option<?php ($size == 'extra-large') ? print ' selected ' : print ''; ?>>extra-large</option>
					<option<?php ($size == 'large') ? print ' selected ' : print ''; ?>>large</option>
					<option<?php ($size == 'middle') ? print ' selected ' : print ''; ?>>middle</option>
					<option<?php ($size == 'small') ? print ' selected ' : print ''; ?>>small</option>
					<option<?php ($size == 'extra-small') ? print ' selected ' : print ''; ?>>extra-small</option>
				</select>
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['text'] = strip_tags($new_instance['text']);
		$instance['url'] = strip_tags($new_instance['url']);
		$instance['reverse'] = strip_tags($new_instance['reverse']);
		$instance['color'] = strip_tags($new_instance['color']);
		$instance['width'] = strip_tags($new_instance['width']);
		$instance['size'] = strip_tags($new_instance['size']);
		return $instance;
	}

	function widget($args, $instance, $echo = TRUE) {
		$ret = '';
		extract($args);
		if (!empty($instance)) {
			$text = $instance['text'];
			$url = $instance['url'];
			$reverse = $instance['reverse'];
			$color = $instance['color'];
			$width = $instance['width'];
			$size = $instance['size'];
		}
		$setting = new BeekSettings();
		$ret .= $before_widget;
		$ret .= '<div class="bwe-widget-wrapper" style="font-size: ' . esc_html($setting->get_base_font_size()) . 'px">';
		$ret .= '<div class="cta-wrapper">';
		if ($text) {
			$ret .= '<a class="cta width-' . $width . ' size-' . $size . ' cta-' . $reverse . '-' . $color . '" href="' . $url . '">' . $text . '</a>';
		}
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= $after_widget;
		if($echo) {
			echo $ret;
			return;
		} else {
			return $ret;
		}
	}

}

/* bwe call to action shortcode */

function bwe_cta($atts) {
	$args = shortcode_atts(array(
		'text' => '',
		'url' => '',
		'reverse' => 'normal',
		'color' => 'black',
		'width' => '70',
		'size' => 'middle'
			), $atts);
	$obj = new BeekCallToAction();
	return $obj->widget($args, array(), FALSE);
}

add_shortcode('bwe_cta', 'bwe_cta');
