<?php
require_once dirname(__FILE__) . '/../beek-widget-extention.php';

class BeekCover extends WP_Widget {

	function BeekCover() {
		parent::__construct('BeekCover', 'Beek Cover Widget', array('description' => __('Image and text and anchor Widget.', 'beek-widget-extention')));
	}

	function form($instance) {
		if ($instance) {
			$image = esc_attr((array_key_exists('image', $instance) ? $instance['image'] : ''));
			$cover_color = esc_attr((array_key_exists('cover_color', $instance) ? $instance['cover_color'] : 'none'));
			$cover_position = esc_attr((array_key_exists('cover_position', $instance) ? $instance['cover_position'] : 'full-width'));
			$title_type = esc_attr((array_key_exists('title_type', $instance) ? $instance['title_type'] : 'h3'));
			$title = esc_attr((array_key_exists('title', $instance) ? $instance['title'] : ''));
			$text = esc_attr((array_key_exists('text', $instance) ? $instance['text'] : ''));
			$text_color = esc_attr((array_key_exists('text_color', $instance) ? $instance['text_color'] : 'white'));
			$url_text = esc_attr((array_key_exists('url_text', $instance) ? $instance['url_text'] : ''));
			$url = esc_attr((array_key_exists('url', $instance) ? $instance['url'] : ''));
			$url_color = esc_attr((array_key_exists('url_color', $instance) ? $instance['url_color'] : 'white'));
			$url_type = esc_attr((array_key_exists('url_type', $instance) ? $instance['url_type'] : 'anchor'));
		} else {
			$image = '';
			$cover_color = 'none';
			$cover_position = 'full-width';
			$title_type = 'h3';
			$title = '';
			$text = '';
			$text_color = 'white';
			$url_text = '';
			$url = '';
			$url_color = 'white';
			$url_type = 'anchor';
		}
		?>
		<div class="bwe-widget-setting">
			<p class="image-selector">
				<?php
				$bwe_access_key = bwe_get_rand_str(16);
				?>
				<label for="<?php echo $this->get_field_id('image'); ?>">
					<?php _e('Image', 'beek-widget-extention'); ?>
				</label>
				<br>
				<span class="bwe-image-preview" style="display: <?php ($image) ? print 'block' : print 'none'; ?>;">
					<img class="bwe-selected-image <?php echo $bwe_access_key; ?>" src="<?php echo $image; ?>" alt="">
				</span>
				<input class="widefat image-url <?php echo $bwe_access_key; ?>" id="<?php echo $this->get_field_id('image'); ?>"
					   name="<?php echo $this->get_field_name('image'); ?>"
					   type="text"
					   value="<?php echo $image; ?>" />
				<a class="select-image" data-target="<?php echo $bwe_access_key; ?>">Select</a>
				<a class="clear-image" data-target="<?php echo $bwe_access_key; ?>">Clear</a>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('cover_color'); ?>">
					<?php _e('Cover Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('cover_color'); ?>"
						name="<?php echo $this->get_field_name('cover_color'); ?>"
						type="text">
					<option<?php ($cover_color == 'none') ? print ' selected ' : print ''; ?>>none</option>
					<option<?php ($cover_color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($cover_color == 'white') ? print ' selected ' : print ''; ?>>white</option>
					<option<?php ($cover_color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($cover_color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($cover_color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($cover_color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($cover_color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($cover_color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($cover_color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('cover_position'); ?>">
					<?php _e('Cover Position', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('cover_position'); ?>"
						name="<?php echo $this->get_field_name('cover_position'); ?>"
						type="text">
					<option<?php ($cover_position == 'full-width') ? print ' selected ' : print ''; ?>>full-width</option>
					<option<?php ($cover_position == 'half-left') ? print ' selected ' : print ''; ?>>half-left</option>
					<option<?php ($cover_position == 'half-right') ? print ' selected ' : print ''; ?>>half-right</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('title_type'); ?>">
					<?php _e('Title Type', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('title_type'); ?>"
						name="<?php echo $this->get_field_name('title_type'); ?>"
						type="text">
					<option<?php ($title_type == 'h1') ? print ' selected ' : print ''; ?>>h1</option>
					<option<?php ($title_type == 'h2') ? print ' selected ' : print ''; ?>>h2</option>
					<option<?php ($title_type == 'h3') ? print ' selected ' : print ''; ?>>h3</option>
					<option<?php ($title_type == 'h4') ? print ' selected ' : print ''; ?>>h4</option>
					<option<?php ($title_type == 'h5') ? print ' selected ' : print ''; ?>>h5</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">
					<?php _e('Title', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
					   name="<?php echo $this->get_field_name('title'); ?>"
					   type="text"
					   value="<?php echo $title; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('text'); ?>">
					<?php _e('Text', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('text'); ?>"
					   name="<?php echo $this->get_field_name('text'); ?>"
					   type="text"
					   value="<?php echo $text; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('text_color'); ?>">
					<?php _e('Text Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('text_color'); ?>"
						name="<?php echo $this->get_field_name('text_color'); ?>"
						type="text">
					<option<?php ($text_color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($text_color == 'white') ? print ' selected ' : print ''; ?>>white</option>
					<option<?php ($text_color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($text_color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($text_color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($text_color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($text_color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($text_color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($text_color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('url_text'); ?>">
					<?php _e('URL Text', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('url_text'); ?>"
					   name="<?php echo $this->get_field_name('url_text'); ?>"
					   type="text"
					   value="<?php echo $url_text; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('url'); ?>">
					<?php _e('URL', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('url'); ?>"
					   name="<?php echo $this->get_field_name('url'); ?>"
					   type="text"
					   value="<?php echo $url; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('url_color'); ?>">
					<?php _e('URL Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('url_color'); ?>"
						name="<?php echo $this->get_field_name('url_color'); ?>"
						type="text">
					<option<?php ($url_color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($url_color == 'white') ? print ' selected ' : print ''; ?>>white</option>
					<option<?php ($url_color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($url_color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($url_color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($url_color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($url_color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($url_color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($url_color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('url_type'); ?>">
					<?php _e('URL Type', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('url_type'); ?>"
						name="<?php echo $this->get_field_name('url_type'); ?>"
						type="text">
					<option<?php ($url_type == 'anchor') ? print ' selected ' : print ''; ?>>anchor</option>
					<option<?php ($url_type == 'button') ? print ' selected ' : print ''; ?>>button</option>
				</select>
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['image'] = strip_tags($new_instance['image']);
		$instance['cover_color'] = strip_tags($new_instance['cover_color']);
		$instance['cover_position'] = strip_tags($new_instance['cover_position']);
		$instance['title_type'] = strip_tags($new_instance['title_type']);
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['text'] = strip_tags($new_instance['text']);
		$instance['text_color'] = strip_tags($new_instance['text_color']);
		$instance['url_text'] = strip_tags($new_instance['url_text']);
		$instance['url'] = strip_tags($new_instance['url']);
		$instance['url_color'] = strip_tags($new_instance['url_color']);
		$instance['url_type'] = strip_tags($new_instance['url_type']);
		return $instance;
	}

	function widget($args, $instance, $echo = TRUE) {
		$ret = '';
		extract($args);
		if (!empty($instance)) {
			$image = $instance['image'];
			$cover_color = $instance['cover_color'];
			$cover_position = $instance['cover_position'];
			$text = $instance['text'];
			$title_type = $instance['title_type'];
			$title = $instance['title'];
			$text_color = $instance['text_color'];
			$url_text = $instance['url_text'];
			$url = $instance['url'];
			$url_color = $instance['url_color'];
			$url_type = $instance['url_type'];
		}
		$setting = new BeekSettings();
		$ret .= $before_widget;
		$ret .= '<div class="bwe-widget-wrapper" style="font-size: ' . esc_html($setting->get_base_font_size()) . 'px">';
		if ($image) {
			$ret .= '<div class="cover-wrapper" style="background-image: url(' . $image . ');">';
			$ret .= '<div class="cover-content cover-color-' . $cover_color . ' cover-content-float-' . $cover_position . '">';
			if ($title) {
				$ret .= '<' . $title_type . ' class="cover-title cover-text-color-' . $text_color . '">' . $title . '</' . $title_type . '>';
			}
			if ($text) {
				$ret .= '<p class="cover-text-color-' . $text_color . '">' . $text . '</p>';
			}
			$ret .= '<a class="cover-anchor-color-' . $url_color . ' type-' . $url_type . '" href="' . $url . '">' . $url_text . '</a>';
			$ret .= '</div>';
			$ret .= '</div>';
		}
		$ret .= '</div>';
		$ret .= $after_widget;

		if ($echo) {
			echo $ret;
			return;
		} else {
			return $ret;
		}
	}

}

/* bwe cover shortcode */

function bwe_cover($atts) {
	$args = shortcode_atts(array(
		'image' => '',
		'cover_color' => 'none',
		'cover_position' => 'full-width',
		'text' => '',
		'title_type' => 'h3',
		'title' => '',
		'text_color' => 'white',
		'url_text' => '',
		'url' => '',
		'url_color' => 'white',
		'url_type' => 'anchor'
			), $atts);
	$obj = new BeekCover();
	return $obj->widget($args, array(), FALSE);
}

add_shortcode('bwe_cover', 'bwe_cover');
