<?php
require_once dirname(__FILE__) . '/../beek-widget-extention.php';

class BeekCustomPostArchive extends WP_Widget {

	function BeekCustomPostArchive() {
		parent::__construct('BeekCustomPostArchive', 'Beek Custom Post Archive Widget', array('description' => __('Custom post month archive list show widget.', 'beek-widget-extention')));
	}

	function form($instance) {
		if ($instance) {
			$title = esc_attr((array_key_exists('title', $instance) ? $instance['title'] : ''));
			$title_size = esc_attr((array_key_exists('title_size', $instance) ? $instance['title_size'] : ''));
			$post_type = esc_attr((array_key_exists('post_type', $instance) ? $instance['post_type'] : ''));
			$output = esc_attr((array_key_exists('output', $instance) ? $instance['output'] : ''));
			$color = esc_attr((array_key_exists('color', $instance) ? $instance['color'] : ''));
		} else {
			$title = '';
			$title_size = 'h3';
			$post_type = 'post';
			$output = 'plain-ul';
			$color = 'black';
		}
		?>
		<div class="bwe-widget-setting">
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">
					<?php _e('Title', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('title'); ?>"
					   name="<?php echo $this->get_field_name('title'); ?>"
					   type="text"
					   value="<?php echo $title; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('title_size'); ?>">
					<?php _e('Title Size', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('title_size'); ?>"
						name="<?php echo $this->get_field_name('title_size'); ?>"
						type="text">
					<option<?php ($title_size == 'h1') ? print ' selected ' : print ''; ?>>h1</option>
					<option<?php ($title_size == 'h2') ? print ' selected ' : print ''; ?>>h2</option>
					<option<?php ($title_size == 'h3') ? print ' selected ' : print ''; ?>>h3</option>
					<option<?php ($title_size == 'h4') ? print ' selected ' : print ''; ?>>h4</option>
					<option<?php ($title_size == 'h5') ? print ' selected ' : print ''; ?>>h5</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('post_type'); ?>">
					<?php _e('Post Type', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('post_type'); ?>"
					   name="<?php echo $this->get_field_name('post_type'); ?>"
					   type="text"
					   value="<?php echo $post_type; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('output'); ?>">
					<?php _e('Output Style', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('output'); ?>"
						name="<?php echo $this->get_field_name('output'); ?>"
						type="text">
					<option<?php ($output == 'plain-ul') ? print ' selected ' : print ''; ?>>plain-ul</option>
					<option<?php ($output == 'decoration-ul') ? print ' selected ' : print ''; ?>>decoration-ul</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('color'); ?>">
					<?php _e('Decoration Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('color'); ?>"
						name="<?php echo $this->get_field_name('color'); ?>"
						type="text">
					<option<?php ($color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['title_size'] = strip_tags($new_instance['title_size']);
		$instance['post_type'] = strip_tags($new_instance['post_type']);
		$instance['output'] = strip_tags($new_instance['output']);
		$instance['color'] = strip_tags($new_instance['color']);
		return $instance;
	}

	function widget($args, $instance, $echo = TRUE) {
		$ret = '';
		extract($args);
		global $bwe_archives_post_type;
		if (!empty($instance)) {
			$title = $instance['title'];
			$title_size = $instance['title_size'];
			$bwe_archives_post_type = $instance['post_type'];
			$output = $instance['output'];
			$color = $instance['color'];
		}
		$setting = new BeekSettings();
		$ret .= $before_widget;
		$ret .= '<div class="bwe-widget-wrapper" style="font-size: ' . esc_html($setting->get_base_font_size()) . 'px">';
		$ret .= '<div class="archive-list-wrapper">';
		if ($title) {
			$ret .= '<' . $title_size . ' class="beek-taxonomy-list-title">' . $title . '</' . $title_size . '>';
		}
		$where_args = array(
			'post_type' => $bwe_archives_post_type,
			'type' => 'monthly',
			'echo' => 0
		);
		$ret .= '<div class="' . $output . ' bwe-color-' . $color . '">';
		$ret .= '<ul>' . wp_get_archives($where_args) . '</ul>';
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= $after_widget;

		if ($echo) {
			echo $ret;
			return;
		} else {
			return $ret;
		}
	}

}

/* bwe custom post archive shortcode */

function bwe_cp_archive($atts) {
	$args = shortcode_atts(array(
		'title' => '',
		'title_size' => 'h3',
		'post_type' => 'post',
		'output' => 'plain-ul',
		'color' => 'black'
			), $atts);
	$obj = new BeekCustomPostArchive();
	return $obj->widget($args, array(), FALSE);
}

add_shortcode('bwe_cp_archive', 'bwe_cp_archive');

