<?php
require_once dirname(__FILE__) . '/../beek-widget-extention.php';

class BeekCustomPostCategory extends WP_Widget {

	function BeekCustomPostCategory() {
		parent::__construct('BeekCustomPostCategory', 'Beek Custom Post Category Widget', array('description' => __('Custom post category show widget.', 'beek-widget-extention')));
	}

	function form($instance) {
		if ($instance) {
			$title = esc_attr((array_key_exists('title', $instance) ? $instance['title'] : ''));
			$title_size = esc_attr((array_key_exists('title_size', $instance) ? $instance['title_size'] : ''));
			$taxonomy = esc_attr((array_key_exists('taxonomy', $instance) ? $instance['taxonomy'] : ''));
			$count = esc_attr((array_key_exists('count', $instance) ? $instance['count'] : ''));
			$smallest = esc_attr((array_key_exists('smallest', $instance) ? $instance['smallest'] : ''));
			$largest = esc_attr((array_key_exists('largest', $instance) ? $instance['largest'] : ''));
			$output = esc_attr((array_key_exists('output', $instance) ? $instance['output'] : ''));
			$color = esc_attr((array_key_exists('color', $instance) ? $instance['color'] : ''));
		} else {
			$title = '';
			$title_size = 'h3';
			$taxonomy = 'category';
			$count = 'show';
			$smallest = '0.8';
			$largest = '1.8';
			$output = 'plain-ul';
			$color = 'black';
		}
		?>
		<div class="bwe-widget-setting">
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">
					<?php _e('Title', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('title'); ?>"
					   name="<?php echo $this->get_field_name('title'); ?>"
					   type="text"
					   value="<?php echo $title; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('title_size'); ?>">
					<?php _e('Title Size', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('title_size'); ?>"
						name="<?php echo $this->get_field_name('title_size'); ?>"
						type="text">
					<option<?php ($title_size == 'h1') ? print ' selected ' : print ''; ?>>h1</option>
					<option<?php ($title_size == 'h2') ? print ' selected ' : print ''; ?>>h2</option>
					<option<?php ($title_size == 'h3') ? print ' selected ' : print ''; ?>>h3</option>
					<option<?php ($title_size == 'h4') ? print ' selected ' : print ''; ?>>h4</option>
					<option<?php ($title_size == 'h5') ? print ' selected ' : print ''; ?>>h5</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('taxonomy'); ?>">
					<?php _e('Taxonomy', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('taxonomy'); ?>"
					   name="<?php echo $this->get_field_name('taxonomy'); ?>"
					   type="text"
					   value="<?php echo $taxonomy; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('count'); ?>">
					<?php _e('Ul Style Post Count Show', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('count'); ?>"
						name="<?php echo $this->get_field_name('count'); ?>"
						type="text">
					<option<?php ($count == 'show') ? print ' selected ' : print ''; ?>>show</option>
					<option<?php ($count == 'hide') ? print ' selected ' : print ''; ?>>hide</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('smallest'); ?>">
					<?php _e('Tag Cloud Smallest Font Size(em)', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('smallest'); ?>"
						name="<?php echo $this->get_field_name('smallest'); ?>"
						type="text">
					<option<?php ($smallest == '0.6') ? print ' selected ' : print ''; ?>>0.6</option>
					<option<?php ($smallest == '0.7') ? print ' selected ' : print ''; ?>>0.7</option>
					<option<?php ($smallest == '0.8') ? print ' selected ' : print ''; ?>>0.8</option>
					<option<?php ($smallest == '0.9') ? print ' selected ' : print ''; ?>>0.9</option>
					<option<?php ($smallest == '1.0') ? print ' selected ' : print ''; ?>>1.0</option>
					<option<?php ($smallest == '1.1') ? print ' selected ' : print ''; ?>>1.1</option>
					<option<?php ($smallest == '1.2') ? print ' selected ' : print ''; ?>>1.2</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('largest'); ?>">
					<?php _e('Tag Cloud Largest Font Size(em)', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('largest'); ?>"
						name="<?php echo $this->get_field_name('largest'); ?>"
						type="text">
					<option<?php ($largest == '1.2') ? print ' selected ' : print ''; ?>>1.2</option>
					<option<?php ($largest == '1.3') ? print ' selected ' : print ''; ?>>1.3</option>
					<option<?php ($largest == '1.4') ? print ' selected ' : print ''; ?>>1.4</option>
					<option<?php ($largest == '1.5') ? print ' selected ' : print ''; ?>>1.5</option>
					<option<?php ($largest == '1.6') ? print ' selected ' : print ''; ?>>1.6</option>
					<option<?php ($largest == '1.7') ? print ' selected ' : print ''; ?>>1.7</option>
					<option<?php ($largest == '1.8') ? print ' selected ' : print ''; ?>>1.8</option>
					<option<?php ($largest == '1.9') ? print ' selected ' : print ''; ?>>1.9</option>
					<option<?php ($largest == '2.0') ? print ' selected ' : print ''; ?>>2.0</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('output'); ?>">
					<?php _e('Output Style', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('output'); ?>"
						name="<?php echo $this->get_field_name('output'); ?>"
						type="text">
					<option<?php ($output == 'plain-ul') ? print ' selected ' : print ''; ?>>plain-ul</option>
					<option<?php ($output == 'plain-tag-cloud') ? print ' selected ' : print ''; ?>>plain-tag-cloud</option>
					<option<?php ($output == 'decoration-ul') ? print ' selected ' : print ''; ?>>decoration-ul</option>
					<option<?php ($output == 'decoration-tag-cloud') ? print ' selected ' : print ''; ?>>decoration-tag-cloud</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('color'); ?>">
					<?php _e('Decoration Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('color'); ?>"
						name="<?php echo $this->get_field_name('color'); ?>"
						type="text">
					<option<?php ($color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['title_size'] = strip_tags($new_instance['title_size']);
		$instance['taxonomy'] = strip_tags($new_instance['taxonomy']);
		$instance['count'] = strip_tags($new_instance['count']);
		$instance['smallest'] = strip_tags($new_instance['smallest']);
		$instance['largest'] = strip_tags($new_instance['largest']);
		$instance['output'] = strip_tags($new_instance['output']);
		$instance['color'] = strip_tags($new_instance['color']);
		return $instance;
	}

	function widget($args, $instance, $echo = TRUE) {
		$ret = '';
		extract($args);
		if (!empty($instance)) {
			$title = $instance['title'];
			$title_size = $instance['title_size'];
			$taxonomy = $instance['taxonomy'];
			$count = $instance['count'];
			$smallest = $instance['smallest'];
			$largest = $instance['largest'];
			$output = $instance['output'];
			$color = $instance['color'];
		}
		$setting = new BeekSettings();
		$ret .= $before_widget;
		$ret .= '<div class="bwe-widget-wrapper" style="font-size: ' . esc_html($setting->get_base_font_size()) . 'px">';
		$ret .= '<div class="tax-list-wrapper">';
		if ($title) {
			$ret .= '<' . $title_size . ' class="beek-taxonomy-list-title">' . $title . '</' . $title_size . '>';
		}
		$ret .= '<div class="' . $output . ' bwe-color-' . $color . '">';
		if ($taxonomy && preg_match('[-ul]', $output)) {
			$ret .= '<ul>';
			$ret .= wp_list_categories(array('title_li' => '', 'echo' => FALSE, 'style' => 'list', 'taxonomy' => $taxonomy, 'show_count' => ($count == "show") ? '1' : '0'));
			$ret .= '</ul>';
		} elseif ($taxonomy && preg_match('[-tag]', $output)) {
			$ret .= wp_tag_cloud(array('taxonomy' => $taxonomy, 'echo' => FALSE, 'smallest' => $smallest, 'largest' => $largest, 'unit' => 'em'));
		}
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= $after_widget;

		if ($echo) {
			echo $ret;
			return;
		} else {
			return $ret;
		}
	}

}

/* bwe custom post category shortcode */

function bwe_cp_category($atts) {
	$args = shortcode_atts(array(
		'title' => '',
		'title_size' => 'h3',
		'taxonomy' => 'category',
		'count' => 'show',
		'smallest' => '0,8',
		'largest' => '1.8',
		'output' => 'plain-ul',
		'color' => 'black'
			), $atts);
	$obj = new BeekCustomPostCategory();
	return $obj->widget($args, array(), FALSE);
}

add_shortcode('bwe_cp_category', 'bwe_cp_category');

