<?php
require_once dirname(__FILE__) . '/../beek-widget-extention.php';

class BeekCustomPostList extends WP_Widget {

	function BeekCustomPostList() {
		parent::__construct('BeekCustomPostList', 'Beek Custom Post List Widget', array('description' => __('Custom post list show widget.', 'beek-widget-extention')));
	}

	function form($instance) {
		if ($instance) {
			$title = esc_attr((array_key_exists('title', $instance) ? $instance['title'] : ''));
			$title_size = esc_attr((array_key_exists('title_size', $instance) ? $instance['title_size'] : 'h3'));
			$post_type = esc_attr((array_key_exists('post_type', $instance) ? $instance['post_type'] : 'post'));
			$taxonomy_slug = esc_attr((array_key_exists('taxonomy_slug', $instance) ? $instance['taxonomy_slug'] : ''));
			$terms = esc_attr((array_key_exists('taxonomy_slug', $instance) ? $instance['terms'] : ''));
			$order = esc_attr((array_key_exists('order', $instance) ? $instance['order'] : 'DESC'));
			$order_by = esc_attr((array_key_exists('order_by', $instance) ? $instance['order_by'] : 'date'));
			$output = esc_attr((array_key_exists('output', $instance) ? $instance['output'] : 'plain-posts'));
			$count = esc_attr((array_key_exists('count', $instance) ? $instance['count'] : '10'));
			$overlay = esc_attr((array_key_exists('overlay', $instance) ? $instance['overlay'] : 'none'));
			$color = esc_attr((array_key_exists('color', $instance) ? $instance['color'] : 'white'));
			$pagination = esc_attr((array_key_exists('pagination', $instance) ? $instance['pagination'] : 'show'));
		} else {
			$title = '';
			$title_size = 'h3';
			$post_type = 'post';
			$taxonomy_slug = 'category';
			$terms = '';
			$order = 'DESC';
			$order_by = 'date';
			$output = 'plain-posts';
			$count = '10';
			$overlay = 'none';
			$color = 'white';
			$pagination = 'show';
		}
		?>
		<div class="bwe-widget-setting">
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">
					<?php _e('Title', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('title'); ?>"
					   name="<?php echo $this->get_field_name('title'); ?>"
					   type="text"
					   value="<?php echo $title; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('title_size'); ?>">
					<?php _e('Title Size', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('title_size'); ?>"
						name="<?php echo $this->get_field_name('title_size'); ?>"
						type="text">
					<option<?php ($title_size == 'h1') ? print ' selected ' : print ''; ?>>h1</option>
					<option<?php ($title_size == 'h2') ? print ' selected ' : print ''; ?>>h2</option>
					<option<?php ($title_size == 'h3') ? print ' selected ' : print ''; ?>>h3</option>
					<option<?php ($title_size == 'h4') ? print ' selected ' : print ''; ?>>h4</option>
					<option<?php ($title_size == 'h5') ? print ' selected ' : print ''; ?>>h5</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('post_type'); ?>">
					<?php _e('Post Type', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('post_type'); ?>"
					   name="<?php echo $this->get_field_name('post_type'); ?>"
					   type="text"
					   value="<?php echo $post_type; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('taxonomy_slug'); ?>">
					<?php _e('Taxonomy slug', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('taxonomy_slug'); ?>"
					   name="<?php echo $this->get_field_name('taxonomy_slug'); ?>"
					   type="text"
					   value="<?php echo $taxonomy_slug; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('terms'); ?>">
					<?php _e('Terms(Category) slug refine', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('terms'); ?>"
					   name="<?php echo $this->get_field_name('terms'); ?>"
					   type="text"
					   value="<?php echo $terms; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('order'); ?>">
					<?php _e('Order', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('order'); ?>"
						name="<?php echo $this->get_field_name('order'); ?>"
						type="text">
					<option<?php ($order == 'DESC') ? print ' selected ' : print ''; ?>>DESC</option>
					<option<?php ($order == 'ASC') ? print ' selected ' : print ''; ?>>ASC</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('order_by'); ?>">
					<?php _e('Order By', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('order_by'); ?>"
						name="<?php echo $this->get_field_name('order_by'); ?>"
						type="text">
					<option<?php ($order_by == 'none') ? print ' selected ' : print ''; ?>>none</option>
					<option<?php ($order_by == 'ID') ? print ' selected ' : print ''; ?>>ID</option>
					<option<?php ($order_by == 'author') ? print ' selected ' : print ''; ?>>author</option>
					<option<?php ($order_by == 'title') ? print ' selected ' : print ''; ?>>title</option>
					<option<?php ($order_by == 'date') ? print ' selected ' : print ''; ?>>date</option>
					<option<?php ($order_by == 'modified') ? print ' selected ' : print ''; ?>>modified</option>
					<option<?php ($order_by == 'comment_count') ? print ' selected ' : print ''; ?>>comment_count</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('output'); ?>">
					<?php _e('Output Style', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('output'); ?>"
						name="<?php echo $this->get_field_name('output'); ?>"
						type="text">
					<option<?php ($output == 'plain-ul') ? print ' selected ' : print ''; ?>>plain-ul</option>
					<option<?php ($output == 'plain-posts') ? print ' selected ' : print ''; ?>>plain-posts</option>
					<option<?php ($output == 'plain-grid-1') ? print ' selected ' : print ''; ?>>plain-grid-1</option>
					<option<?php ($output == 'plain-grid-2') ? print ' selected ' : print ''; ?>>plain-grid-2</option>
					<option<?php ($output == 'plain-grid-3') ? print ' selected ' : print ''; ?>>plain-grid-3</option>
					<option<?php ($output == 'plain-grid-4') ? print ' selected ' : print ''; ?>>plain-grid-4</option>
					<option<?php ($output == 'decoration-ul') ? print ' selected ' : print ''; ?>>decoration-ul</option>
					<option<?php ($output == 'decoration-posts') ? print ' selected ' : print ''; ?>>decoration-posts</option>
					<option<?php ($output == 'decoration-grid-1') ? print ' selected ' : print ''; ?>>decoration-grid-1</option>
					<option<?php ($output == 'decoration-grid-2') ? print ' selected ' : print ''; ?>>decoration-grid-2</option>
					<option<?php ($output == 'decoration-grid-3') ? print ' selected ' : print ''; ?>>decoration-grid-3</option>
					<option<?php ($output == 'decoration-grid-4') ? print ' selected ' : print ''; ?>>decoration-grid-4</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('count'); ?>">
					<?php _e('Show Post Count', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('count'); ?>"
						name="<?php echo $this->get_field_name('count'); ?>"
						type="text">
					<option<?php ($count == '1') ? print ' selected ' : print ''; ?>>1</option>
					<option<?php ($count == '2') ? print ' selected ' : print ''; ?>>2</option>
					<option<?php ($count == '3') ? print ' selected ' : print ''; ?>>3</option>
					<option<?php ($count == '4') ? print ' selected ' : print ''; ?>>4</option>
					<option<?php ($count == '5') ? print ' selected ' : print ''; ?>>5</option>
					<option<?php ($count == '6') ? print ' selected ' : print ''; ?>>6</option>
					<option<?php ($count == '7') ? print ' selected ' : print ''; ?>>7</option>
					<option<?php ($count == '8') ? print ' selected ' : print ''; ?>>8</option>
					<option<?php ($count == '9') ? print ' selected ' : print ''; ?>>9</option>
					<option<?php ($count == '10') ? print ' selected ' : print ''; ?>>10</option>
					<option<?php ($count == '11') ? print ' selected ' : print ''; ?>>11</option>
					<option<?php ($count == '12') ? print ' selected ' : print ''; ?>>12</option>
					<option<?php ($count == '13') ? print ' selected ' : print ''; ?>>13</option>
					<option<?php ($count == '14') ? print ' selected ' : print ''; ?>>14</option>
					<option<?php ($count == '15') ? print ' selected ' : print ''; ?>>15</option>
					<option<?php ($count == '16') ? print ' selected ' : print ''; ?>>16</option>
					<option<?php ($count == '17') ? print ' selected ' : print ''; ?>>17</option>
					<option<?php ($count == '18') ? print ' selected ' : print ''; ?>>18</option>
					<option<?php ($count == '19') ? print ' selected ' : print ''; ?>>19</option>
					<option<?php ($count == '20') ? print ' selected ' : print ''; ?>>20</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('overlay'); ?>">
					<?php _e('Overlay on Hover', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('overlay'); ?>"
						name="<?php echo $this->get_field_name('overlay'); ?>"
						type="text">
					<option<?php ($overlay == 'none') ? print ' selected ' : print ''; ?>>none</option>
					<option<?php ($overlay == 'overlay') ? print ' selected ' : print ''; ?>>overlay</option>
					<option<?php ($overlay == 'reverse-overlay') ? print ' selected ' : print ''; ?>>reverse-overlay</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('color'); ?>">
					<?php _e('Decoration Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('color'); ?>"
						name="<?php echo $this->get_field_name('color'); ?>"
						type="text">
					<option<?php ($color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($color == 'white') ? print ' selected ' : print ''; ?>>white</option>
					<option<?php ($color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('pagination'); ?>">
					<?php _e('Pagination', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('pagination'); ?>"
						name="<?php echo $this->get_field_name('pagination'); ?>"
						type="text">
					<option<?php ($pagination == 'hide') ? print ' selected ' : print ''; ?>>hide</option>
					<option<?php ($pagination == 'show') ? print ' selected ' : print ''; ?>>show</option>
					<option<?php ($pagination == 'ajax-load') ? print ' selected ' : print ''; ?>>ajax-load</option>
					<option<?php ($pagination == 'ajax-auto-load') ? print ' selected ' : print ''; ?>>ajax-auto-load</option>
				</select>
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['title_size'] = strip_tags($new_instance['title_size']);
		$instance['post_type'] = strip_tags($new_instance['post_type']);
		$instance['taxonomy_slug'] = strip_tags($new_instance['taxonomy_slug']);
		$instance['terms'] = strip_tags($new_instance['terms']);
		$instance['order'] = strip_tags($new_instance['order']);
		$instance['order_by'] = strip_tags($new_instance['order_by']);
		$instance['output'] = strip_tags($new_instance['output']);
		$instance['count'] = strip_tags($new_instance['count']);
		$instance['overlay'] = strip_tags($new_instance['overlay']);
		$instance['color'] = strip_tags($new_instance['color']);
		$instance['pagination'] = strip_tags($new_instance['pagination']);
		return $instance;
	}

	function widget($args, $instance, $echo = TRUE) {
		$ret = '';
		extract($args);
		if (!empty($instance)) {
			$title = $instance['title'];
			$title_size = $instance['title_size'];
			$post_type = $instance['post_type'];
			$taxonomy_slug = $instance['taxonomy_slug'];
			$terms = $instance['terms'];
			$order = $instance['order'];
			$order_by = $instance['order_by'];
			$output = $instance['output'];
			$count = $instance['count'];
			$overlay = $instance['overlay'];
			$color = $instance['color'];
			$pagination = $instance['pagination'];
		}
		$setting = new BeekSettings();
		if ($pagination == 'hide') {
			$paged = 1;
		} elseif (get_query_var('page')) {
			$paged = get_query_var('page');
		} elseif (get_query_var('paged')) {
			$paged = get_query_var('paged');
		} else {
			$paged = 1;
		}
		$ret .= $before_widget;
		$ret .= '<div class="bwe-widget-wrapper" style="font-size: ' . esc_html($setting->get_base_font_size()) . 'px">';
		$ret .= '<div class="post-list-wrapper">';
		if ($title) {
			$ret .= '<' . $title_size . ' class="beek-post-list-title">' . $title . '</' . $title_size . '>';
		}
		if ($post_type) {
			$query_res = $this->beek_get_post($post_type, $order, $order_by, $count, $paged, $taxonomy_slug, $terms);
			if ($query_res->have_posts()) {
				if (preg_match('[-ul]', $output)) {
					$ret .= $this->output_post_ul($query_res, $output, $color, TRUE);
				} elseif (preg_match('[-grid]', $output)) {
					$ret .= $this->output_post_grid($query_res, $output, $overlay, $color, $taxonomy_slug, TRUE);
				} elseif (preg_match('[-posts]', $output)) {
					$ret .= $this->output_post_posts($query_res, $output, $overlay, $color, $taxonomy_slug, TRUE);
				}
			} else {
				$ret .= '<p>' . __('No Posts', 'beek-widget-extention') . '</p>';
			}
		}
		if ($pagination == 'show') {
			$ret .= $this->pagination($color, $paged, $query_res->max_num_pages);
		} elseif ($pagination == 'ajax-load') {
			$obj_color = (preg_match('[plain]', $output)) ? '' : 'bwe-color-' . $color;
			if (preg_match('[-ul]', $output)) {
				$ret .= '<a href="#" class="bwe-ajax-load ' . $obj_color . '" id="bwe-get-post-list" data-post-type="' . $post_type . '" data-taxonomy-slug="' . $taxonomy_slug . '" data-order="' . $order . '" data-order-by="' . $order_by . '" data-output="' . $output . '" data-count="' . $count . '" data-overlay="' . $overlay . '" data-color="' . $color . '" data-page="1" data-message=".ajax-message-area" data-parent=".' . $output . '">' . __('Load more articles', 'beek-widget-extention') . '</a>';
			} elseif (preg_match('[-grid]', $output)) {
				$ret .= '<a href="#" class="bwe-ajax-load ' . $obj_color . '" id="bwe-get-post-list" data-post-type="' . $post_type . '" data-taxonomy-slug="' . $taxonomy_slug . '" data-order="' . $order . '" data-order-by="' . $order_by . '" data-output="' . $output . '" data-count="' . $count . '" data-overlay="' . $overlay . '" data-color="' . $color . '" data-page="1" data-message=".ajax-message-area" data-parent=".basic-grid-style">' . __('Load more articles', 'beek-widget-extention') . '</a>';
			} elseif (preg_match('[-posts]', $output)) {
				$ret .= '<a href="#" class="bwe-ajax-load ' . $obj_color . '" id="bwe-get-post-list" data-post-type="' . $post_type . '" data-taxonomy-slug="' . $taxonomy_slug . '" data-order="' . $order . '" data-order-by="' . $order_by . '" data-output="' . $output . '" data-count="' . $count . '" data-overlay="' . $overlay . '" data-color="' . $color . '" data-page="1" data-message=".ajax-message-area" data-parent=".basic-posts-style">' . __('Load more articles', 'beek-widget-extention') . '</a>';
			}
			$ret .= '<div class="ajax-message-area ' . $obj_color . '"></div>';
		} elseif ($pagination == 'ajax-auto-load') {
			$obj_color = (preg_match('[plain]', $output)) ? '' : 'bwe-color-' . $color;
			if (preg_match('[-ul]', $output)) {
				$ret .= '<div id="bwe-get-post-list" data-post-type="' . $post_type . '" data-taxonomy-slug="' . $taxonomy_slug . '" data-order="' . $order . '" data-order-by="' . $order_by . '" data-output="' . $output . '" data-count="' . $count . '" data-overlay="' . $overlay . '" data-color="' . $color . '" data-page="1" data-message=".ajax-message-area" data-parent=".' . $output . '"></div>';
			} elseif (preg_match('[-grid]', $output)) {
				$ret .= '<div id="bwe-get-post-list" data-post-type="' . $post_type . '" data-taxonomy-slug="' . $taxonomy_slug . '" data-order="' . $order . '" data-order-by="' . $order_by . '" data-output="' . $output . '" data-count="' . $count . '" data-overlay="' . $overlay . '" data-color="' . $color . '" data-page="1" data-message=".ajax-message-area" data-parent=".basic-grid-style"></div>';
			} elseif (preg_match('[-posts]', $output)) {
				$ret .= '<div id="bwe-get-post-list" data-post-type="' . $post_type . '" data-taxonomy-slug="' . $taxonomy_slug . '" data-order="' . $order . '" data-order-by="' . $order_by . '" data-output="' . $output . '" data-count="' . $count . '" data-overlay="' . $overlay . '" data-color="' . $color . '" data-page="1" data-message=".ajax-message-area" data-parent=".basic-posts-style"></div>';
			}
			$ret .= '<div id="bwe-ajax-autoload" class="ajax-message-area ' . $obj_color . '"></div>';
		}
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= $after_widget;
		wp_reset_postdata();

		if ($echo) {
			echo $ret;
			return;
		} else {
			return $ret;
		}
	}

	public function beek_get_post($post_type, $order, $order_by, $count, $paged, $taxonomy, $terms) {
		$args = array();
		if ($taxonomy && $terms) {
			$args = array(
				'post_type' => $post_type,
				'order' => $order,
				'orderby' => $order_by,
				'posts_per_page' => $count,
				'paged' => $paged,
				'tax_query' => array(
					array(
						'taxonomy' => $taxonomy,
						'field' => 'slug',
						'terms' => $terms,
					),
				)
			);
		} else {
			$args = array(
				'post_type' => $post_type,
				'order' => $order,
				'orderby' => $order_by,
				'posts_per_page' => $count,
				'paged' => $paged
			);
		}
		$wp_query = new WP_Query($args);
		return $wp_query;
	}

	public function output_post_ul($query, $output, $color, $echo_wrapper) {
		$ret = '';
		if ($query->have_posts()) {
			if ($echo_wrapper) {
				$ret .= '<ul class="' . $output . ' bwe-color-' . $color . '">';
			}
			while ($query->have_posts()) {
				$query->the_post();
				$ret .= '<li><span>' . get_the_date() . '</span><a href="' . get_the_permalink() . '">' . get_the_title() . '</a></li>';
			}
			if ($echo_wrapper) {
				$ret .= '</ul>';
			}
		}
		return $ret;
	}

	public function output_post_grid($query, $output, $overlay, $color, $taxonomy_slug, $wrapper_echo) {
		$setting = new BeekSettings();
		$grid = 12;
		$col = 1;
		$cnt = 0;
		$ret = '';
		if (strstr($output, '-1')) {
			$grid = 12;
			$col = 1;
		} elseif (strstr($output, '-2')) {
			$grid = 6;
			$col = 2;
		} elseif (strstr($output, '-3')) {
			$grid = 4;
			$col = 3;
		} elseif (strstr($output, '-4')) {
			$grid = 3;
			$col = 4;
		}
		$type = (strstr($output, 'plain')) ? 'plain-grid' : 'decoration-grid';
		if ($query->have_posts()) {
			if ($wrapper_echo) {
				$ret .= '<div class="basic-grid-style ' . $type . ' bwe-color-' . $color . '">';
			}
			$ret .= '<div class="bwe-row">';
			while ($query->have_posts()) {
				if ($cnt % $col == 0 && $cnt != 0) {
					$ret .= '</div><div class="bwe-row">';
				}
				$cnt++;
				$query->the_post();
				$ret .= '<article class="bwe-col span_' . $grid . '">';
				$ret .= '<div class="post-thumbnail">';
				if (has_post_thumbnail()) {
					$ret .= '<a href="' . get_the_permalink() . '">';
					$ret .= '<div class="image-sizing effect-' . $overlay . ' effect-color-' . $color . '">';
					$image_id = get_post_thumbnail_id();
					$image_url = wp_get_attachment_image_src($image_id, true);
					$ret .= '<img src="' . $image_url[0] . '" alt="">';
					$ret .= '</div>';
					$ret .= '</a>';
				} else {
					if ($setting->get_no_image()) {
						$ret .= '<a href="' . get_the_permalink() . '">';
						$ret .= '<div class="image-sizing effect-' . $overlay . ' effect-color-' . $color . '">';
						$ret .= '<img src="' . $setting->get_no_image() . '" alt="">';
						$ret .= '</div>';
						$ret .= '</a>';
					} else {
						$ret .= '<p>No thumbnail</p>';
					}
				}
				$ret .= '</div>';
				$ret .= '<div class = "post-entry-data">';
				$ret .= '<div class = "title">';
				$ret .= '<h3><a href = "' . get_the_permalink() . '">' . get_the_title() . '</a></h3>';
				$ret .= '</div>';
				if ($taxonomy_slug) {
					$ret .= '<div class = "categories">';
					$ret .= get_the_term_list($post->ID, $taxonomy_slug);
					$ret .= '</div>';
				}
				$ret .= '<div class = "meta">';
				$ret .= '<span class = "date">' . get_the_date() . '</span>';
				$ret .= '<span class = "author">' . __('Posted by', 'beek-widget-extention');
				$ret .= '<a href = "' . get_author_posts_url(get_the_author_meta('ID')) . '">' . get_the_author() . '</a>';
				$ret .= '</span>';
				$ret .= '</div>';
				$ret .= '<div class = "content">';
				$ret .= '<p>' . get_the_excerpt() . '</p>';
				$ret .= '</div>';
				$ret .= '<div class = "more">';
				$ret .= '<a href = "' . get_the_permalink() . '">' . __('More...', 'beek-widget-extention') . '</a>';
				$ret .= '</div>';
				$ret .= '</div>';
				$ret .= '</article>';
			}
			$ret .= '</div>';
			if ($wrapper_echo) {
				$ret .= '</div>';
			}
		}
		return $ret;
	}

	public function output_post_posts($query, $output, $overlay, $color, $taxonomy_slug, $echo_wrapper) {
		$setting = new BeekSettings();
		$ret = '';
		if ($query->have_posts()) {
			if ($echo_wrapper) {
				$ret .= '<div class = "basic-posts-style ' . $output . ' bwe-color-' . $color . '">';
			}
			while ($query->have_posts()) {
				$query->the_post();
				$ret .= '<article class = "bwe-row">';
				$ret .= '<div class = "post-thumbnail bwe-col span_6">';
				if (has_post_thumbnail()) {
					$ret .= '<a href = "' . get_the_permalink() . '">';
					$ret .= '<div class = "effect-' . $overlay . ' effect-color-' . $color . '">';
					$image_id = get_post_thumbnail_id();
					$image_url = wp_get_attachment_image_src($image_id, true);
					$ret .= '<img src="' . $image_url[0] . '" alt="">';
					$ret .= '</div>';
					$ret .= '</a>';
				} else {
					if ($setting->get_no_image()) {
						$ret .= '<a href = "' . get_the_permalink() . '">';
						$ret .= '<div class = "effect-' . $overlay . ' effect-color-' . $color . '">';
						$ret .= '<img src="' . $setting->get_no_image() . '" alt="">';
						$ret .= '</div>';
						$ret .= '</a>';
					} else {
						$ret .= '<p>No thumbnail</p>';
					}
				}
				$ret .= '</div>';
				$ret .= '<div class = "post-entry-data bwe-color-' . $color . ' bwe-col span_6">';
				$ret .= '<div class = "title">';
				$ret .= '<h3><a href = "' . get_the_permalink() . '">' . get_the_title() . '</a></h3>';
				$ret .= '</div>';
				if ($taxonomy_slug) {
					$ret .= '<div class = "categories">';
					$ret .= get_the_term_list($post->ID, $taxonomy_slug);
					$ret .= '</div>';
				}
				$ret .= '<div class = "meta">';
				$ret .= '<span class = "date">' . get_the_date() . '</span>';
				$ret .= '<span class = "author">' . __('Posted by', 'beek-widget-extention');
				$ret .= '<a href = "' . get_author_posts_url(get_the_author_meta('ID')) . '">' . get_the_author() . '</a>';
				$ret .= '</span>';
				$ret .= '</div>';
				$ret .= '<div class = "content">';
				$ret .= '<p>' . get_the_excerpt() . '</p>';
				$ret .= '</div>';
				$ret .= '<div class = "more">';
				$ret .= '<a href = "' . get_the_permalink() . '">' . __('More...', 'beek-widget-extention') . '</a>';
				$ret .= '</div>';
				$ret .= '</div>';
				$ret .= '</article>';
			}
			if ($echo_wrapper) {
				$ret .= '</div>';
			}
		}
		return $ret;
	}

	private function pagination($color, $paged, $pages = '', $range = 2) {
		$ret = '';
		$ret .= '<div class = "bwe-pagination pagination-color-' . $color . '">';
		if (empty($paged)) {
			$paged = 1;
		}
		if (1 != $pages) {
			for ($i = 1; $i <= $pages; $i++) {
				if (1 != $pages && (!($i >= $paged + $range + 1 || $i <= $paged - $range - 1) || $pages <= $showitems )) {
					if ($i != $paged) {
						$ret .= '<a href = "' . get_pagenum_link($i) . '">' . $i . '</a>';
					} else {
						$ret .= '<a class = "active">' . $i . '</a>';
					}
				}
			}
		}
		$ret .= '</div>';
		return $ret;
	}

}

/* bwe custom post list shortcode */

function bwe_cp_list($atts) {
	$args = shortcode_atts(array(
		'title' => '',
		'title_size' => 'h3',
		'post_type' => 'post',
		'taxonomy_slug' => 'category',
		'order' => 'DESC',
		'order_by' => 'date',
		'output' => 'plain-posts',
		'count' => '10',
		'overlay' => 'none',
		'color' => 'white',
		'pagination' => 'show',
			), $atts);
	$obj = new BeekCustomPostList();
	return $obj->widget($args, array(), FALSE);
}

add_shortcode('bwe_cp_list', 'bwe_cp_list');


/* Ajax */

function add_bwe_post_list_ajax_url() {
	echo '<script>var bwe_post_list_ajax_url = "' . admin_url('admin-ajax.php') . '";</script>';
}

add_action('wp_head', 'add_bwe_post_list_ajax_url', 1);

function bwe_get_post_list() {
	$keys = array('post_type', 'taxonomy_slug', 'order', 'order_by', 'output', 'count', 'overlay', 'color', 'page');
	$bweObj = new BeekCustomPostList();
	$all_post_data = filter_input_array(INPUT_POST);
	$ret = array();
	if (!array_key_exists('bwe_ajax_get_post_list_data', $all_post_data)) {
		$ret['res'] = FALSE;
		$ret['code'] = 100;
		$ret['message'] = __('Parameter is abnormal', 'beek-widget-extention');
		echo json_encode($ret);
		die();
	}
	$bwe_ajax_data = $all_post_data['bwe_ajax_get_post_list_data'];
	if (!array_keys_exists($keys, $bwe_ajax_data)) {
		$ret['res'] = FALSE;
		$ret['code'] = 200;
		$ret['message'] = __('Parameter is abnormal', 'beek-widget-extention');
		echo json_encode($ret);
		die();
	}
	$post_type = $bwe_ajax_data['post_type'];
	$taxonomy_slug = $bwe_ajax_data['taxonomy_slug'];
	$terms = $bwe_ajax_data['terms'];
	$order = $bwe_ajax_data['order'];
	$order_by = $bwe_ajax_data['order_by'];
	$output = $bwe_ajax_data['output'];
	$count = $bwe_ajax_data['count'];
	$overlay = $bwe_ajax_data['overlay'];
	$color = $bwe_ajax_data['color'];
	$page = $bwe_ajax_data['page'];

	$post_list_data = $bweObj->beek_get_post($post_type, $order, $order_by, $count, $page, $taxonomy_slug, $terms);
	if (!$post_list_data->have_posts()) {
		$ret['res'] = FALSE;
		$ret['code'] = 300;
		$ret['message'] = __('Did load all', 'beek-widget-extention');
		echo json_encode($ret);
		die();
	}

	if (preg_match('[-ul]', $output)) {
		$ret['data'] = $bweObj->output_post_ul($post_list_data, $output, $color, FALSE);
	} elseif (preg_match('[-grid]', $output)) {
		$ret['data'] = $bweObj->output_post_grid($post_list_data, $output, $overlay, $color, $taxonomy_slug, FALSE);
	} elseif (preg_match('[-posts]', $output)) {
		$ret['data'] = $bweObj->output_post_posts($post_list_data, $output, $overlay, $color, $taxonomy_slug, FALSE);
	}
	$ret['res'] = TRUE;
	echo json_encode($ret);
	die();
}

add_action('wp_ajax_bwe_get_post_list', 'bwe_get_post_list');
add_action('wp_ajax_nopriv_bwe_get_post_list', 'bwe_get_post_list');

/* array_key_exists wrapper */

function array_keys_exists($keys, $array) {
	if (empty($keys) || empty($array)) {
		return FALSE;
	}
	foreach ($keys as $value) {
		if (!array_key_exists($value, $array)) {
			return FALSE;
		}
	}
	return TRUE;
}
