<?php
require_once dirname(__FILE__) . '/../beek-widget-extention.php';

class BeekHeading extends WP_Widget {

	function BeekHeading() {
		parent::__construct('BeekHeading', 'Beek Heading Widget', array('description' => __('simple heading and text widget.', 'beek-widget-extention')));
	}

	function form($instance) {
		if ($instance) {
			$heading = esc_attr((array_key_exists('heading', $instance) ? $instance['heading'] : 'h2'));
			$text_align = esc_attr((array_key_exists('text_align', $instance) ? $instance['text_align'] : 'center'));
			$title = esc_attr((array_key_exists('title', $instance) ? $instance['title'] : ''));
			$title_bold = esc_attr((array_key_exists('title_bold', $instance) ? $instance['title_bold'] : 'normal'));
			$text = esc_attr((array_key_exists('text', $instance) ? $instance['text'] : ''));
			$border_type = esc_attr((array_key_exists('border_type', $instance) ? $instance['border_type'] : 'solid'));
			$border_color = esc_attr((array_key_exists('border_color', $instance) ? $instance['border_color'] : 'black'));
			$border_width = esc_attr((array_key_exists('border_width', $instance) ? $instance['border_width'] : '2'));
		} else {
			$heading = 'h2';
			$text_align = 'center';
			$title = '';
			$title_bold = 'normal';
			$text = '';
			$border_type = 'solid';
			$border_color = 'black';
			$border_width = '2';
		}
		?>
		<div class="bwe-widget-setting">
			<p>
				<label for="<?php echo $this->get_field_id('heading'); ?>">
					<?php _e('Type', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('heading'); ?>"
						name="<?php echo $this->get_field_name('heading'); ?>"
						type="text">
					<option<?php ($heading == 'h1') ? print ' selected ' : print ''; ?>>h1</option>
					<option<?php ($heading == 'h2') ? print ' selected ' : print ''; ?>>h2</option>
					<option<?php ($heading == 'h3') ? print ' selected ' : print ''; ?>>h3</option>
					<option<?php ($heading == 'h4') ? print ' selected ' : print ''; ?>>h4</option>
					<option<?php ($heading == 'h5') ? print ' selected ' : print ''; ?>>h5</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('text_align'); ?>">
					<?php _e('Text Align', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('text_align'); ?>"
						name="<?php echo $this->get_field_name('text_align'); ?>"
						type="text">
					<option<?php ($text_align == 'left') ? print ' selected ' : print ''; ?>>left</option>
					<option<?php ($text_align == 'center') ? print ' selected ' : print ''; ?>>center</option>
					<option<?php ($text_align == 'right') ? print ' selected ' : print ''; ?>>right</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">
					<?php _e('Title', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>"
					   name="<?php echo $this->get_field_name('title'); ?>"
					   type="text"
					   value="<?php echo $title; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('title_bold'); ?>">
					<?php _e('Title Bold', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('title_bold'); ?>"
						name="<?php echo $this->get_field_name('title_bold'); ?>"
						type="text">
					<option<?php ($title_bold == 'normal') ? print ' selected ' : print ''; ?>>normal</option>
					<option<?php ($title_bold == 'bold') ? print ' selected ' : print ''; ?>>bold</option>
					<option<?php ($title_bold == 'lighter') ? print ' selected ' : print ''; ?>>lighter</option>
					<option<?php ($title_bold == 'bolder') ? print ' selected ' : print ''; ?>>bolder</option>
					<option<?php ($title_bold == '100') ? print ' selected ' : print ''; ?>>100</option>
					<option<?php ($title_bold == '200') ? print ' selected ' : print ''; ?>>200</option>
					<option<?php ($title_bold == '300') ? print ' selected ' : print ''; ?>>300</option>
					<option<?php ($title_bold == '400') ? print ' selected ' : print ''; ?>>400</option>
					<option<?php ($title_bold == '500') ? print ' selected ' : print ''; ?>>500</option>
					<option<?php ($title_bold == '600') ? print ' selected ' : print ''; ?>>600</option>
					<option<?php ($title_bold == '700') ? print ' selected ' : print ''; ?>>700</option>
					<option<?php ($title_bold == '800') ? print ' selected ' : print ''; ?>>800</option>
					<option<?php ($title_bold == '900') ? print ' selected ' : print ''; ?>>900</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('text'); ?>">
					<?php _e('Text', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('text'); ?>"
					   name="<?php echo $this->get_field_name('text'); ?>"
					   type="text"
					   value="<?php echo $text; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('border_type'); ?>">
					<?php _e('Border Type', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('border_type'); ?>"
						name="<?php echo $this->get_field_name('border_type'); ?>"
						type="text">
					<option<?php ($border_type == 'none') ? print ' selected ' : print ''; ?>>none</option>
					<option<?php ($border_type == 'solid') ? print ' selected ' : print ''; ?>>solid</option>
					<option<?php ($border_type == 'double') ? print ' selected ' : print ''; ?>>double</option>
					<option<?php ($border_type == 'groove') ? print ' selected ' : print ''; ?>>groove</option>
					<option<?php ($border_type == 'ridge') ? print ' selected ' : print ''; ?>>ridge</option>
					<option<?php ($border_type == 'dashed') ? print ' selected ' : print ''; ?>>dashed</option>
					<option<?php ($border_type == 'dotted') ? print ' selected ' : print ''; ?>>dotted</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('border_color'); ?>">
					<?php _e('Border Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('border_color'); ?>"
						name="<?php echo $this->get_field_name('border_color'); ?>"
						type="text">
					<option<?php ($border_color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($border_color == 'white') ? print ' selected ' : print ''; ?>>white</option>
					<option<?php ($border_color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($border_color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($border_color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($border_color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($border_color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($border_color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($border_color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('border_width'); ?>">
					<?php _e('Border Width', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('border_width'); ?>"
					   name="<?php echo $this->get_field_name('border_width'); ?>"
					   type="number"
					   min="0"
					   max="20"
					   value="<?php echo $border_width; ?>" />
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['heading'] = strip_tags($new_instance['heading']);
		$instance['text_align'] = strip_tags($new_instance['text_align']);
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['title_bold'] = strip_tags($new_instance['title_bold']);
		$instance['text'] = strip_tags($new_instance['text']);
		$instance['border_type'] = strip_tags($new_instance['border_type']);
		$instance['border_color'] = strip_tags($new_instance['border_color']);
		$instance['border_width'] = strip_tags($new_instance['border_width']);
		return $instance;
	}

	function widget($args, $instance, $echo = TRUE) {
		$ret = '';
		extract($args);
		if (!empty($instance)) {
			$heading = $instance['heading'];
			$text_align = $instance['text_align'];
			$title = $instance['title'];
			$title_bold = $instance['title_bold'];
			$text = $instance['text'];
			$border_type = $instance['border_type'];
			$border_color = $instance['border_color'];
			$border_width = $instance['border_width'];
		}
		$border_width .= 'px';
		$setting = new BeekSettings();
		$ret .= $before_widget;
		$ret .= '<div class="bwe-widget-wrapper" style="font-size: ' . esc_html($setting->get_base_font_size()) . 'px">';
		$ret .= '<div class="heading-wrapper">';
		if ($title) {
			$ret .= '<' . $heading . ' class="heading-widget-title border-color-' . $border_color . ' border-style-' . $border_type . '" style="border-bottom-width: ' . $border_width . ';text-align: ' . $text_align . ';font-weight: ' . $title_bold . ';">' . $title . '</' . $heading . '>';
		}
		if ($text) {
			$ret .= '<p class="heading-widget-text" style="text-align: ' . $text_align . ';">' . $text . '</p>';
		}
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= $after_widget;

		if ($echo) {
			echo $ret;
			return;
		} else {
			return $ret;
		}
	}

}

/* bwe heading shortcode */

function bwe_heading($atts) {
	$args = shortcode_atts(array(
		'heading' => 'h3',
		'text_align' => 'center',
		'title' => '',
		'title_bold' => 'normal',
		'text' => '',
		'border_type' => 'solid',
		'border_color' => 'black',
		'border_width' => '2'
			), $atts);
	$obj = new BeekHeading();
	return $obj->widget($args, array(), FALSE);
}

add_shortcode('bwe_heading', 'bwe_heading');



