<?php
require_once dirname(__FILE__) . '/../beek-widget-extention.php';

class BeekImage extends WP_Widget {

	function BeekImage() {
		parent::__construct('BeekImage', 'Beek Image Widget', array('description' => __('simple image widget.', 'beek-widget-extention')));
	}

	function form($instance) {
		if ($instance) {
			$image = esc_attr((array_key_exists('image', $instance) ? $instance['image'] : ''));
			$overlay = esc_attr((array_key_exists('overlay', $instance) ? $instance['overlay'] : 'none'));
			$overlay_color = esc_attr((array_key_exists('overlay_color', $instance) ? $instance['overlay_color'] : 'white'));
			$alt = esc_attr((array_key_exists('alt', $instance) ? $instance['alt'] : ''));
			$url = esc_attr((array_key_exists('url', $instance) ? $instance['url'] : ''));
		} else {
			$image = '';
			$overlay = 'none';
			$overlay_color = 'white';
			$alt = '';
			$url = '';
		}
		?>
		<div class="bwe-widget-setting">
			<p class="image-selector">
				<?php
				$bwe_access_key = bwe_get_rand_str(16);
				?>
				<label for="<?php echo $this->get_field_id('image'); ?>">
					<?php _e('Image', 'beek-widget-extention'); ?>
				</label>
				<br>
				<span class="bwe-image-preview" style="display: <?php ($image) ? print 'block' : print 'none'; ?>;">
					<img class="bwe-selected-image <?php echo $bwe_access_key; ?>" src="<?php echo $image; ?>" alt="">
				</span>
				<input class="widefat image-url <?php echo $bwe_access_key; ?>" id="<?php echo $this->get_field_id('image'); ?>"
					   name="<?php echo $this->get_field_name('image'); ?>"
					   type="text"
					   value="<?php echo $image; ?>" />
				<a class="select-image" data-target="<?php echo $bwe_access_key; ?>">Select</a>
				<a class="clear-image" data-target="<?php echo $bwe_access_key; ?>">Clear</a>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('overlay'); ?>">
					<?php _e('Overlay on Hover', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('overlay'); ?>"
						name="<?php echo $this->get_field_name('overlay'); ?>"
						type="text">
					<option<?php ($overlay == 'none') ? print ' selected ' : print ''; ?>>none</option>
					<option<?php ($overlay == 'overlay') ? print ' selected ' : print ''; ?>>overlay</option>
					<option<?php ($overlay == 'reverse-overlay') ? print ' selected ' : print ''; ?>>reverse-overlay</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('overlay_color'); ?>">
					<?php _e('Overlay Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('overlay_color'); ?>"
						name="<?php echo $this->get_field_name('overlay_color'); ?>"
						type="text">
					<option<?php ($overlay_color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($overlay_color == 'white') ? print ' selected ' : print ''; ?>>white</option>
					<option<?php ($overlay_color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($overlay_color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($overlay_color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($overlay_color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($overlay_color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($overlay_color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($overlay_color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('alt'); ?>">
					<?php _e('Alt', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('alt'); ?>"
					   name="<?php echo $this->get_field_name('alt'); ?>"
					   type="text"
					   value="<?php echo $alt; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('url'); ?>">
					<?php _e('URL', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat" id="<?php echo $this->get_field_id('url'); ?>"
					   name="<?php echo $this->get_field_name('url'); ?>"
					   type="text"
					   value="<?php echo $url; ?>" />
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['image'] = strip_tags($new_instance['image']);
		$instance['overlay'] = strip_tags($new_instance['overlay']);
		$instance['overlay_color'] = strip_tags($new_instance['overlay_color']);
		$instance['alt'] = strip_tags($new_instance['alt']);
		$instance['url'] = strip_tags($new_instance['url']);
		return $instance;
	}

	function widget($args, $instance, $echo = TRUE) {
		$ret = '';
		extract($args);
		if (!empty($instance)) {
			$image = $instance['image'];
			$overlay = $instance['overlay'];
			$overlay_color = $instance['overlay_color'];
			$alt = $instance['alt'];
			$url = $instance['url'];
		}
		$setting = new BeekSettings();
		$ret .= $before_widget;
		$ret .= '<div class="bwe-widget-wrapper" style="font-size: ' . $setting->get_base_font_size() . 'px">';
		$ret .= '<div class="image-wrapper">';
		if ($image) {
			$ret .= ($url) ? '<a href="' . $url . '">' : '';
			$ret .= '<div class="effect-' . $overlay . ' effect-color-' . $overlay_color . '">';
			$ret .= '<img src="' . $image . '" alt="' . $alt . '">';
			$ret .= '</div>';
			$ret .= ($url) ? '</a>' : '';
		}
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= $after_widget;

		if ($echo) {
			echo $ret;
			return;
		} else {
			return $ret;
		}
	}

}

/* bwe image shortcode */

function bwe_image($atts) {
	$args = shortcode_atts(array(
		'image' => '',
		'overlay' => 'none',
		'overlay_color' => 'white',
		'alt' => '',
		'url' => ''
			), $atts);
	$obj = new BeekImage();
	return $obj->widget($args, array(), FALSE);
}

add_shortcode('bwe_image', 'bwe_image');

