<?php
require_once dirname(__FILE__) . '/../beek-widget-extention.php';

class BeekMenu extends WP_Widget {

	function BeekMenu() {
		parent::__construct('BeekMenu', 'Beek Menu Widget', array('description' => __('show menu widget.', 'beek-widget-extention')));
	}

	function form($instance) {
		if ($instance) {
			$title = esc_attr((array_key_exists('title', $instance) ? $instance['title'] : ''));
			$title_size = esc_attr((array_key_exists('title_size', $instance) ? $instance['title_size'] : ''));
			$menu_name = esc_attr((array_key_exists('menu_name', $instance) ? $instance['menu_name'] : ''));
			$output = esc_attr((array_key_exists('output', $instance) ? $instance['output'] : ''));
			$color = esc_attr((array_key_exists('color', $instance) ? $instance['color'] : ''));
			$font_size = esc_attr((array_key_exists('font_size', $instance) ? $instance['font_size'] : 'medium'));
		} else {
			$title = '';
			$title_size = 'h3';
			$menu_name = '';
			$output = '';
			$color = 'black';
			$font_size = 'medium';
		}
		?>
		<div class="bwe-widget-setting">
			<p>
				<label for="<?php echo $this->get_field_id('title'); ?>">
					<?php _e('Title', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('title'); ?>"
					   name="<?php echo $this->get_field_name('title'); ?>"
					   type="text"
					   value="<?php echo $title; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('title_size'); ?>">
					<?php _e('Title Size', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('title_size'); ?>"
						name="<?php echo $this->get_field_name('title_size'); ?>"
						type="text">
					<option<?php ($title_size == 'h1') ? print ' selected ' : print ''; ?>>h1</option>
					<option<?php ($title_size == 'h2') ? print ' selected ' : print ''; ?>>h2</option>
					<option<?php ($title_size == 'h3') ? print ' selected ' : print ''; ?>>h3</option>
					<option<?php ($title_size == 'h4') ? print ' selected ' : print ''; ?>>h4</option>
					<option<?php ($title_size == 'h5') ? print ' selected ' : print ''; ?>>h5</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('menu_name'); ?>">
					<?php _e('Menu Name', 'beek-widget-extention'); ?>
				</label>
				<input class="widefat image-url" id="<?php echo $this->get_field_id('menu_name'); ?>"
					   name="<?php echo $this->get_field_name('menu_name'); ?>"
					   type="text"
					   value="<?php echo $menu_name; ?>" />
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('output'); ?>">
					<?php _e('Output Style', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('output'); ?>"
						name="<?php echo $this->get_field_name('output'); ?>"
						type="text">
					<option<?php ($output == 'plain-ul') ? print ' selected ' : print ''; ?>>plain-ul</option>
					<option<?php ($output == 'decoration-ul') ? print ' selected ' : print ''; ?>>decoration-ul</option>
					<option<?php ($output == 'header-menu') ? print ' selected ' : print ''; ?>>header-menu</option>
					<option<?php ($output == 'parent-grid-1') ? print ' selected ' : print ''; ?>>parent-grid-1</option>
					<option<?php ($output == 'parent-grid-2') ? print ' selected ' : print ''; ?>>parent-grid-2</option>
					<option<?php ($output == 'parent-grid-3') ? print ' selected ' : print ''; ?>>parent-grid-3</option>
					<option<?php ($output == 'parent-grid-4') ? print ' selected ' : print ''; ?>>parent-grid-4</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('color'); ?>">
					<?php _e('Decoration Color', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('color'); ?>"
						name="<?php echo $this->get_field_name('color'); ?>"
						type="text">
					<option<?php ($color == 'black') ? print ' selected ' : print ''; ?>>black</option>
					<option<?php ($color == 'white') ? print ' selected ' : print ''; ?>>white</option>
					<option<?php ($color == 'red') ? print ' selected ' : print ''; ?>>red</option>
					<option<?php ($color == 'pink') ? print ' selected ' : print ''; ?>>pink</option>
					<option<?php ($color == 'purple') ? print ' selected ' : print ''; ?>>purple</option>
					<option<?php ($color == 'indigo') ? print ' selected ' : print ''; ?>>indigo</option>
					<option<?php ($color == 'blue') ? print ' selected ' : print ''; ?>>blue</option>
					<option<?php ($color == 'green') ? print ' selected ' : print ''; ?>>green</option>
					<option<?php ($color == 'orange') ? print ' selected ' : print ''; ?>>orange</option>
				</select>
			</p>
			<p>
				<label for="<?php echo $this->get_field_id('font_size'); ?>">
					<?php _e('Font Size', 'beek-widget-extention'); ?>
				</label>
				<select class="widefat" id="<?php echo $this->get_field_id('font_size'); ?>"
						name="<?php echo $this->get_field_name('font_size'); ?>"
						type="text">
					<option<?php ($font_size == 'extra-small') ? print ' selected ' : print ''; ?>>extra-small</option>
					<option<?php ($font_size == 'small') ? print ' selected ' : print ''; ?>>small</option>
					<option<?php ($font_size == 'medium') ? print ' selected ' : print ''; ?>>medium</option>
					<option<?php ($font_size == 'large') ? print ' selected ' : print ''; ?>>large</option>
					<option<?php ($font_size == 'extra-large') ? print ' selected ' : print ''; ?>>extra-large</option>
				</select>
			</p>
		</div>
		<?php
	}

	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['title_size'] = strip_tags($new_instance['title_size']);
		$instance['menu_name'] = strip_tags($new_instance['menu_name']);
		$instance['output'] = strip_tags($new_instance['output']);
		$instance['color'] = strip_tags($new_instance['color']);
		$instance['font_size'] = strip_tags($new_instance['font_size']);
		return $instance;
	}

	function widget($args, $instance, $echo = TRUE) {
		$ret = '';
		extract($args);
		if (!empty($instance)) {
			$title = $instance['title'];
			$title_size = $instance['title_size'];
			$menu_name = $instance['menu_name'];
			$output = $instance['output'];
			$color = $instance['color'];
			$font_size = $instance['font_size'];
		}
		$setting = new BeekSettings();
		$ret .= $before_widget;
		$ret .= '<div class="bwe-widget-wrapper" style="font-size: ' . esc_html($setting->get_base_font_size()) . 'px">';
		$ret .= '<div class="bwe-menu-wrapper ' . $output . ' bwe-color-' . $color . ' bwe-font-size-' . $font_size . '">';
		if ($title) {
			$ret .= '<' . $title_size . ' class="bwe-menu-title">' . $title . '</' . $title_size . '>';
		}
		if (preg_match('[-ul]', $output)) {
			$ret .= '<div class="bwe-menu-ul-style-container">';
			$ret .= wp_nav_menu(array('menu' => $menu_name, 'echo' => false));
			$ret .= '</div>';
		} elseif (preg_match('[header-]', $output)) {
			$ret .= '<div class="bwe-menu-header-style-container">';
			$ret .= wp_nav_menu(array('menu' => $menu_name, 'echo' => false));
			$ret .= '</div>';
		} elseif (preg_match('[grid-]', $output)) {
			$grid = 12;
			if (strstr($output, '-1')) {
				$grid = 12;
			} elseif (strstr($output, '-2')) {
				$grid = 6;
			} elseif (strstr($output, '-3')) {
				$grid = 4;
			} elseif (strstr($output, '-4')) {
				$grid = 3;
			}
			$ret .= '<div class="bwe-menu-grid-style-container bwe-row">';
			$ret .= wp_nav_menu(array('menu' => $menu_name, 'echo' => false, 'items_wrap' => '%3$s', 'depth' => 1, 'walker' => new Bwe_Nav_Walker($grid)));
			$ret .= '</div>';
		}
		$ret .= '</div>';
		$ret .= '</div>';
		$ret .= $after_widget;

		if ($echo) {
			echo $ret;
			return;
		} else {
			return $ret;
		}
	}

}

class Bwe_Nav_Walker extends Walker_Nav_Menu {

	private $grid_col = 12;

	function __construct($grid_col) {
		$this->grid_col = $grid_col;
	}

	function start_el(&$output, $item, $depth, $args) {

		$classes = empty($item->classes) ? array() : (array) $item->classes;
		$class_names = join(' ', apply_filters('nav_menu_css_class', array_filter($classes), $item));
		!empty($class_names) and $class_names = ' class="bwe-col span_' . $this->grid_col . ' ' . esc_attr($class_names) . '"';
		$output .= "<div id='menu-item-$item->ID' $class_names>";
		$attributes = '';
		!empty($item->attr_title) and $attributes .= ' title="' . esc_attr($item->attr_title) . '"';
		!empty($item->target) and $attributes .= ' target="' . esc_attr($item->target) . '"';
		!empty($item->xfn) and $attributes .= ' rel="' . esc_attr($item->xfn) . '"';
		!empty($item->url) and $attributes .= ' href="' . esc_attr($item->url) . '"';
		$title = apply_filters('the_title', $item->title, $item->ID);
		$item_output = $args->before
				. "<a $attributes>"
				. $args->link_before
				. $title
				. '</a></div>'
				. $args->link_after
				. $args->after;
		$output .= apply_filters('walker_nav_menu_start_el', $item_output, $item, $depth, $args);
	}

}

/* bwe menu shortcode */

function bwe_menu($atts) {
	$args = shortcode_atts(array(
		'title' => '',
		'title_size' => 'h3',
		'menu_name' => '',
		'output' => 'plain-ul',
		'color' => 'black',
		'font_size' => 'medium'
			), $atts);
	$obj = new BeekMenu();
	return $obj->widget($args, array(), FALSE);
}

add_shortcode('bwe_menu', 'bwe_menu');

